/******************************************************************************/
/*                          COUNTER VARIABLES.
*******************************************************************************/
extern long Sym_Cnt;                                         /* Symbol count. */
extern long Err_Cnt;                                   /* Symbol error count. */
extern long Valid_Sym;                                 /* Valid symbol count. */
/******************************************************************************/
/*                      BIT AND SYMBOL VARIABLES.
*******************************************************************************/
extern int Bit[BITS_PER_SYM];                             /* Stores the bits. */
extern int Inp_Sym_Num;                         /* Sym. no. i/p to diff. enc. */
extern int Radius_Num;                              /* Current radius number. */
extern int Curr_Tx_Sym_Num;                           /* Curr. tx. symbol no. */
extern int Prev_Tx_Sym_Num;                           /* Prev. tx. symbol no. */
extern double Re_Sym;                          /* Re. part of current symbol. */
extern double Im_Sym;                          /* Im. part of current symbol. */
extern double Rx_Re_Sym[DIVERSITY];                /* Re. part of rx. symbol. */
extern double Rx_Im_Sym[DIVERSITY];                /* Im. part of rx. symbol. */
extern double Re_Map[CONSTELL_SIZE];                          /* Re. mapping. */
extern double Im_Map[CONSTELL_SIZE];                          /* Im. mapping. */
extern double Re_Inv_Map[CONSTELL_SIZE];               /* Re. symbol inverse. */
extern double Im_Inv_Map[CONSTELL_SIZE];               /* Im. symbol inverse. */
extern double Inv_Mag_Sq[CONSTELL_SIZE];         /* Inv. mag. sq. of symbols. */
extern double Log_Mag[CONSTELL_SIZE];        /* Log_e of mag. sq. of symbols. */
/******************************************************************************/
/*                        FADE GENERATOR VARIABLES.
*******************************************************************************/
extern long Sym_Energy_Cnt;                /* To compute the avg. tx. energy. */
extern unsigned short F1_Store[DIVERSITY][PNS_SIZE];    /* Stores PNS status. */
extern unsigned short F2_Store[DIVERSITY][PNS_SIZE];    /* Stores PNS status. */
extern double F_Val[DIVERSITY][NVALSIZE];        /* Contains U & G rand. var. */
extern double Re_Fade[DIVERSITY];               /* Re. part of fade variable. */
extern double Im_Fade[DIVERSITY];               /* Im. part of fade variable. */
extern double Ip_Coeff;                                 /* IIR coeff. of i/p. */
extern double Ip_Coeff_Inv_Sq;                      /* Inv. sq. of i/p coeff. */
extern double Coeff_Array[PRED_MEM_SIZE];               /* IIR coeff. of o/p. */
extern double Re_F_Reg[DIVERSITY][PRED_MEM_SIZE];           /* Re. pred. reg. */
extern double Im_F_Reg[DIVERSITY][PRED_MEM_SIZE];           /* Im. pred. reg. */
extern double Sym_Energy[DIVERSITY];                 /* Energy in the symbol. */
extern double Max_Env_Sq[DIVERSITY];               /* Max. value of envelope. */
extern double Min_Env_Sq[DIVERSITY];               /* Min. value of envelope. */
/******************************************************************************/
/*                       NOISE GENERATOR VARIABLES.
*******************************************************************************/
extern unsigned short N1_Store[DIVERSITY][PNS_SIZE];    /* Stores PNS status. */
extern unsigned short N2_Store[DIVERSITY][PNS_SIZE];    /* Stores PNS status. */
extern double N_Val[DIVERSITY][NVALSIZE];        /* Contains U & G rand. var. */
/******************************************************************************/
/*                   RECEIVER INPUT REGISTER VARIABLES.
*******************************************************************************/
extern double Re_Rx_Reg[DIVERSITY][RX_REG_SIZE];       /* Stores Re. samples. */
extern double Im_Rx_Reg[DIVERSITY][RX_REG_SIZE];       /* Stores Im. samples. */
/******************************************************************************/
/*                   RECEIVED SIGNAL AFTER DATA DEMODULATION.
*******************************************************************************/
extern double Re_Data_Dmod[DIVERSITY][RX_REG_SIZE];        /* Re. data demod. */
extern double Im_Data_Dmod[DIVERSITY][RX_REG_SIZE];        /* Im. data demod. */
/******************************************************************************/
/*                    VARIABLES RELATED TO ERROR BUFFER.
*******************************************************************************/
extern int Err_Buf_Inx;                             /* Index to error buffer. */
extern int Err_Buf[ERR_BUF_SIZE];                            /* Error buffer. */
/******************************************************************************/
/*                    VARIABLES RELATED TO THE TRELLIS.
*******************************************************************************/
extern int P_State;                                         /* Present state. */
extern int P_Input;                                         /* Present input. */
extern int Trel_NS[NUM_STATES][NUM_INPUTS];                    /* Next state. */
extern int State_Array[NUM_STATES][PRED_MEM_SIZE];    /* State in M-ary form. */
/******************************************************************************/
/*                    VARIABLES RELATED TO THE VITERBI.
*******************************************************************************/
extern int Depth;                       /* Gives the current depth of the VA. */
extern int VA_Inp;                               /* Current input to a state. */
extern int VA_P_St;                                         /* Current state. */
extern int VA_N_St;                                            /* Next state. */
extern int Min_Wght_St;                     /* State with the minimum weight. */
extern int Curr_VA_Op_Sym_Num;         /* Curr. symbol number released by VA. */
extern int Prev_VA_Op_Sym_Num;         /* Prev. symbol number released by VA. */
extern int Diff_Decoded_Sym;                         /* Diff. decoded symbol. */
extern double Curr_Error_Sq;                         /* Curr. error variance. */
extern double New_Wght;                                      /* New net wght. */
extern double Old_Wght;                                      /* Old net wght. */
extern struct Trellis *Fst_Depth;                               /* Templates. */
extern struct Trellis *Lst_Depth;                               /* Templates. */
/******************************************************************************/
