/******************************************************************************/
/*                          COUNTER VARIABLES.
*******************************************************************************/
long Sym_Cnt;                                                /* Symbol count. */
long Err_Cnt;                                          /* Symbol error count. */
long Valid_Sym;                                        /* Valid symbol count. */
/******************************************************************************/
/*                      BIT AND SYMBOL VARIABLES.
*******************************************************************************/
int Bit[BITS_PER_SYM];                                    /* Stores the bits. */
int Inp_Sym_Num;                                /* Sym. no. i/p to diff. enc. */
int Radius_Num;                                     /* Current radius number. */
int Curr_Tx_Sym_Num;                                  /* Curr. tx. symbol no. */
int Prev_Tx_Sym_Num;                                  /* Prev. tx. symbol no. */
double Re_Sym;                                 /* Re. part of current symbol. */
double Im_Sym;                                 /* Im. part of current symbol. */
double Rx_Re_Sym[DIVERSITY];                       /* Re. part of rx. symbol. */
double Rx_Im_Sym[DIVERSITY];                       /* Im. part of rx. symbol. */
double Re_Map[CONSTELL_SIZE];                                 /* Re. mapping. */
double Im_Map[CONSTELL_SIZE];                                 /* Im. mapping. */
double Re_Inv_Map[CONSTELL_SIZE];                      /* Re. symbol inverse. */
double Im_Inv_Map[CONSTELL_SIZE];                      /* Im. symbol inverse. */
double Inv_Mag_Sq[CONSTELL_SIZE];                /* Inv. mag. sq. of symbols. */
double Log_Mag[CONSTELL_SIZE];               /* Log_e of mag. sq. of symbols. */
/******************************************************************************/
/*                        FADE GENERATOR VARIABLES.
*******************************************************************************/
long Sym_Energy_Cnt;                       /* To compute the avg. tx. energy. */
unsigned short F1_Store[DIVERSITY][PNS_SIZE];           /* Stores PNS status. */
unsigned short F2_Store[DIVERSITY][PNS_SIZE];           /* Stores PNS status. */
double F_Val[DIVERSITY][NVALSIZE];               /* Contains U & G rand. var. */
double Re_Fade[DIVERSITY];                      /* Re. part of fade variable. */
double Im_Fade[DIVERSITY];                      /* Im. part of fade variable. */
double Ip_Coeff;                                        /* IIR coeff. of i/p. */
double Ip_Coeff_Inv_Sq;                             /* Inv. sq. of i/p coeff. */
double Coeff_Array[PRED_MEM_SIZE];                      /* IIR coeff. of o/p. */
double Re_F_Reg[DIVERSITY][PRED_MEM_SIZE];                  /* Re. pred. reg. */
double Im_F_Reg[DIVERSITY][PRED_MEM_SIZE];                  /* Im. pred. reg. */
double Sym_Energy[DIVERSITY];                        /* Energy in the symbol. */
double Max_Env_Sq[DIVERSITY];                      /* Max. value of envelope. */
double Min_Env_Sq[DIVERSITY];                      /* Min. value of envelope. */
/******************************************************************************/
/*                       NOISE GENERATOR VARIABLES.
*******************************************************************************/
unsigned short N1_Store[DIVERSITY][PNS_SIZE];           /* Stores PNS status. */
unsigned short N2_Store[DIVERSITY][PNS_SIZE];           /* Stores PNS status. */
double N_Val[DIVERSITY][NVALSIZE];               /* Contains U & G rand. var. */
/******************************************************************************/
/*                   RECEIVER INPUT REGISTER VARIABLES.
*******************************************************************************/
double Re_Rx_Reg[DIVERSITY][RX_REG_SIZE];              /* Stores Re. samples. */
double Im_Rx_Reg[DIVERSITY][RX_REG_SIZE];              /* Stores Im. samples. */
/******************************************************************************/
/*                   RECEIVED SIGNAL AFTER DATA DEMODULATION.
*******************************************************************************/
double Re_Data_Dmod[DIVERSITY][RX_REG_SIZE];               /* Re. data demod. */
double Im_Data_Dmod[DIVERSITY][RX_REG_SIZE];               /* Im. data demod. */
/******************************************************************************/
/*                    VARIABLES RELATED TO ERROR BUFFER.
*******************************************************************************/
int Err_Buf_Inx;                                    /* Index to error buffer. */
int Err_Buf[ERR_BUF_SIZE];                                   /* Error buffer. */
/******************************************************************************/
/*                    VARIABLES RELATED TO THE TRELLIS.
*******************************************************************************/
int P_State;                                                /* Present state. */
int P_Input;                                                /* Present input. */
int Trel_NS[NUM_STATES][NUM_INPUTS];                           /* Next state. */
int State_Array[NUM_STATES][PRED_MEM_SIZE];           /* State in M-ary form. */
/******************************************************************************/
/*                    VARIABLES RELATED TO THE VITERBI.
*******************************************************************************/
int Depth;                              /* Gives the current depth of the VA. */
int VA_Inp;                                      /* Current input to a state. */
int VA_P_St;                                                /* Current state. */
int VA_N_St;                                                   /* Next state. */
int Min_Wght_St;                            /* State with the minimum weight. */
int Curr_VA_Op_Sym_Num;                /* Curr. symbol number released by VA. */
int Prev_VA_Op_Sym_Num;                /* Prev. symbol number released by VA. */
int Diff_Decoded_Sym;                                /* Diff. decoded symbol. */
double Curr_Error_Sq;                                /* Curr. error variance. */
double New_Wght;                                             /* New net wght. */
double Old_Wght;                                             /* Old net wght. */
struct Trellis *Fst_Depth;                                      /* Templates. */
struct Trellis *Lst_Depth;                                      /* Templates. */
/******************************************************************************/
