/******************************************************************************/
#include "p2type.h"
#include "p2ext.h"
/******************************************************************************/
int Pre_Processor()
{
 Ck_Var();
 Get_Mapping();
 Get_Inv_Mapping();
 Get_Trellis();
 Sim_Init();
 return(0);
}
/******************************************************************************/
/*                      Get the mapping to constellation.
*******************************************************************************/
int Get_Mapping()
{
 if(BITS_PER_SYM == 3)
  QAM_08_Mapping();
 return(0);
}
/******************************************************************************/
/*                             8-QAM mapping.
*******************************************************************************/
int QAM_08_Mapping()
{
 Get_Re_Map();
 Get_Im_Map();
 return(0);
}
/******************************************************************************/
/*                           Get real mapping.
*******************************************************************************/
int Get_Re_Map()
{
 double tmp;
 tmp=1.0+sqrt(3.0);
 Re_Map[0]=  1.0;
 Re_Map[1]= -1.0;
 Re_Map[2]= -1.0;
 Re_Map[3]=  1.0;
 Re_Map[4]=  0.0;
 Re_Map[5]= -tmp;
 Re_Map[6]=  0.0;
 Re_Map[7]=  tmp;
 return(0);
}
/******************************************************************************/
/*                           Get imaginary mapping.
*******************************************************************************/
int Get_Im_Map()
{
 double tmp;
 tmp=1.0+sqrt(3.0);
 Im_Map[0]=  1.0;
 Im_Map[1]=  1.0;
 Im_Map[2]= -1.0;
 Im_Map[3]= -1.0;
 Im_Map[4]=  tmp;
 Im_Map[5]=  0.0;
 Im_Map[6]= -tmp ;
 Im_Map[7]=  0.0;
 return(0);
}
/******************************************************************************/
/*                     Get the inverse of the symbols.
*******************************************************************************/
int Get_Inv_Mapping()
{
 int cnt;
 double magsq;
 for(cnt=ZERO;cnt<CONSTELL_SIZE;cnt++)
 {
  magsq=Re_Map[cnt]*Re_Map[cnt]+Im_Map[cnt]*Im_Map[cnt];
  if(magsq<ERROR)
   Error_Mes(22);
  Re_Inv_Map[cnt]=  Re_Map[cnt]/magsq;
  Im_Inv_Map[cnt]= -Im_Map[cnt]/magsq;
  Inv_Mag_Sq[cnt]=1.0/magsq;
  Log_Mag[cnt]=log(magsq);
 }
 return(0);
}
/******************************************************************************/
