/******************************************************************************/
#include "p2type.h"
#include "p2ext.h"
/******************************************************************************/
int Simulation()
{
 for(Sym_Cnt=ZERO;Sym_Cnt<FRAME_SIZE;Sym_Cnt++)
 {
  Get_Symbol();
  Add_Noise();
  Receive();
 }
 return(0);
}
/******************************************************************************/
/*                        Add white Gaussian noise.
*******************************************************************************/
int Add_Noise()
{
 int cntd;
 double erand48();
 for(cntd=ZERO;cntd<DIVERSITY;cntd++)
 {
  N_Val[cntd][URADIUS]=erand48(N1_Store[cntd]);
  N_Val[cntd][UTHETA]= erand48(N2_Store[cntd]);
  My_Gauss(VARIANCE,N_Val,cntd);
  Rx_Re_Sym[cntd]=Rx_Re_Sym[cntd]+N_Val[cntd][GRAND_0];
  Rx_Im_Sym[cntd]=Rx_Im_Sym[cntd]+N_Val[cntd][GRAND_1];
 }
 return(0);
}
/******************************************************************************/
/*                         Sample the MF output.
*******************************************************************************/
int Receive()
{
 Shift_In_New_Sample();
 if(Sym_Cnt >= PRED_MEM_SIZE)
  Viterbi();
 if(Sym_Cnt >= (RX_REG_SIZE+VA_DEPTH-ONE))
 {
  Get_Diff_Decoded_Sym();
  Update_Error();
 }
 return(0);
}
/******************************************************************************/
/*                      Shift in a new complex sample.
*******************************************************************************/
int Shift_In_New_Sample()
{
 int cntd;
 Right_Shift(Re_Rx_Reg,Im_Rx_Reg);
 for(cntd=ZERO;cntd<DIVERSITY;cntd++)
 {
  Re_Rx_Reg[cntd][ZERO]=Rx_Re_Sym[cntd];
  Im_Rx_Reg[cntd][ZERO]=Rx_Im_Sym[cntd];
 }
 return(0);
}
/******************************************************************************/
/*                  Get the differentially decoded symbol.
*******************************************************************************/
int Get_Diff_Decoded_Sym()
{
 int prev_rad,curr_rad,ip_rad,prev_lsb,curr_lsb,ip_lsb;
 prev_rad=Prev_VA_Op_Sym_Num/SYM_PER_RADIUS;
 curr_rad=Curr_VA_Op_Sym_Num/SYM_PER_RADIUS;
 ip_rad=(prev_rad+curr_rad)%NUM_RADII;
 prev_lsb=Prev_VA_Op_Sym_Num%SYM_PER_RADIUS;
 curr_lsb=Curr_VA_Op_Sym_Num%SYM_PER_RADIUS;
 if(curr_lsb < prev_lsb)
  curr_lsb=SYM_PER_RADIUS+curr_lsb;
 ip_lsb=curr_lsb-prev_lsb;
 if((prev_rad == ONE) && (curr_rad == ZERO))
  ip_lsb--;
 if(ip_lsb < ZERO)
  ip_lsb=ip_lsb+SYM_PER_RADIUS;
 if(ip_lsb >= SYM_PER_RADIUS)
  Error_Mes(24);
 Diff_Decoded_Sym=ip_rad*SYM_PER_RADIUS+ip_lsb;
 return(0);
}
/******************************************************************************/
/*                     Update the symbol error count.
*******************************************************************************/
int Update_Error()
{
 int cnt;
 Valid_Sym++;
 if(Err_Buf[RX_REG_SIZE] != Diff_Decoded_Sym)
 {
  /*printf("frmcnt:%d symcnt:%d ",Frame_Cnt,Sym_Cnt);
  printf("tx sym:%d rx sym:%d\n",Err_Buf[RX_REG_SIZE],Diff_Decoded_Sym);*/
  Err_Cnt++;
 }
 Shift_Err_Buf();
 return(0);
}
/******************************************************************************/
/*                   Shift the contents of the error buffer.
*******************************************************************************/
int Shift_Err_Buf()
{
 int cnt;
 for(cnt=ZERO;cnt<=(Err_Buf_Inx-2);cnt++)
  Err_Buf[cnt]=Err_Buf[cnt+ONE];
 Err_Buf_Inx--;
 if(Err_Buf_Inx < ZERO)
  Error_Mes(15);
 return(0);
}
/******************************************************************************/
