/******************************************************************************/
#include "p3type.h"
#include "p3ext.h"
/******************************************************************************/
/*                   Get the symbol to be transmitted.
*******************************************************************************/
int Get_Symbol()
{
 if(Sym_Cnt == ZERO)
  Re_Init_Sim();
 Comm_Sym();
 if(Sym_Cnt > ZERO)
  Shift_Into_Err_Buf();
 if(FADING)
  Introduce_Fading();
 else
  Retain_Symbol();
 Up_Tx_Energy();
 Prev_Tx_Sym_Num=Curr_Tx_Sym_Num;
 return(0);
}
/******************************************************************************/
/*                       Initialize the receiver.
*******************************************************************************/
int Re_Init_Sim()
{
 Err_Buf_Inx=ZERO;
 return(0);
}
/******************************************************************************/
/*                     Symbols during communication.
*******************************************************************************/
int Comm_Sym()
{
 Get_Bits();
 Inp_Sym_Num=Binary_to_Decimal(Bit,BITS_PER_SYM);
 Mapping();
 return(0);
}
/******************************************************************************/
/*                              Get the bits.
*******************************************************************************/
int Get_Bits()
{
 int cnt;
 int random(void);
 for(cnt=ZERO;cnt<BITS_PER_SYM;cnt++)
  Bit[cnt]=random()&01;
 return(0);
}
/******************************************************************************/
/*                               Map to symbol.
*******************************************************************************/
int Mapping()
{
 if((Inp_Sym_Num) && (Prev_Tx_Sym_Num))
  Curr_Tx_Sym_Num=ZERO;
 else if((Inp_Sym_Num) && (!Prev_Tx_Sym_Num))
  Curr_Tx_Sym_Num=ONE;
 else
  Curr_Tx_Sym_Num=Prev_Tx_Sym_Num;
 Re_Sym=Re_Map[Curr_Tx_Sym_Num];
 /*if((Sym_Cnt>7250) && (Sym_Cnt<7300))
  printf("getsym:prev:%d curr:%d\n",Prev_Tx_Sym_Num,Curr_Tx_Sym_Num);*/
 return(0);
}
/******************************************************************************/
/*                         Shift into error buffer.
*******************************************************************************/
int Shift_Into_Err_Buf()
{
 /*if((Sym_Cnt>7250) && (Sym_Cnt<7300))
  printf("getsym: symcnt:%d symnum:%d\n",Sym_Cnt,Inp_Sym_Num);*/
 Err_Buf[Err_Buf_Inx]=Inp_Sym_Num;
 Err_Buf_Inx++;
 if(Err_Buf_Inx == ERR_BUF_SIZE)
  Error_Mes(11);
 return(0);
}
/******************************************************************************/
/*                            Introduce fading.
*******************************************************************************/
int Introduce_Fading()
{
 Get_Cmplx_Variable();
 Get_Modified_Symbol();
 return(0);
}
/******************************************************************************/
/*                    Get the complex random variable.
*******************************************************************************/
int Get_Cmplx_Variable()
{
 int cntd;
 double erand48();
 for(cntd=ZERO;cntd<DIVERSITY;cntd++)
 {
  F_Val[cntd][URADIUS]=erand48(F1_Store[cntd]);
  F_Val[cntd][UTHETA]= erand48(F2_Store[cntd]);
  My_Gauss(F_VARIANCE,F_Val,cntd);
  Get_Re_Fade(cntd);
  Update_Env(cntd);
 }
 return(0);
}
/******************************************************************************/
/*                            Get Re. fade.
*******************************************************************************/
int Get_Re_Fade(cntd)
int cntd;
{
 int cnt;
 Re_Fade[cntd]=0.00001*F_Val[cntd][GRAND_0];
 for(cnt=ZERO;cnt<PRED_MEM_SIZE;cnt++)
  Re_Fade[cntd]=Re_Fade[cntd]-Coeff_Array[cnt]*Re_F_Reg[cnt];
 for(cnt=PRED_MEM_SIZE-ONE;cnt>ZERO;cnt--)
  Re_F_Reg[cnt]=Re_F_Reg[cnt-ONE];
 Re_F_Reg[ZERO]=Re_Fade[cntd];
 return(0);
}
/******************************************************************************/
/*         Update the maximum and minimum values of the envelope.
*******************************************************************************/
int Update_Env(cntd)
int cntd;
{
 double mag,re_tmp;
 re_tmp=Re_Fade[cntd]+F_BIAS;
 mag=re_tmp*re_tmp;
 if(mag > Max_Env_Sq[cntd])
  Max_Env_Sq[cntd]=mag;
 else if(mag < Min_Env_Sq[cntd])
  Min_Env_Sq[cntd]=mag;
 /*if((Sym_Cnt>0) && (Sym_Cnt<10000))
 {
  printf("refip:%lf ",F_Val[0][GRAND_0]);
  printf("refade:%lf\n",Re_Fade[0]);
 }*/
 return(0);
}
/******************************************************************************/
/*                        Get the modified symbol.
*******************************************************************************/
int Get_Modified_Symbol()
{
 int cntd;
 for(cntd=ZERO;cntd<DIVERSITY;cntd++)
  Rx_Re_Sym[cntd]=Re_Sym*(Re_Fade[cntd]+F_BIAS);
 return(0);
}
/******************************************************************************/
/*               Retain the original distortion free symbol.
*******************************************************************************/
int Retain_Symbol()
{
 Rx_Re_Sym[ZERO]=Re_Sym;
 return(0);
}
/******************************************************************************/
/*                     Update the transmitted energy.
*******************************************************************************/
int Up_Tx_Energy()
{
 int cntd;
 double energy;
 for(cntd=ZERO;cntd<DIVERSITY;cntd++)
 {
  energy=Rx_Re_Sym[cntd]*Rx_Re_Sym[cntd];
  Sym_Energy[cntd]=Sym_Energy[cntd]+energy;
 }
 Sym_Energy_Cnt++;
 return(0);
}
/******************************************************************************/
