/******************************************************************************/
#include "p3type.h"
#include "p3ext.h"
/******************************************************************************/
/*                            Postprocessor.
*******************************************************************************/
int Viterbi()
{
 if(Depth<(VA_DEPTH-ONE))
  Pre_VA_Depth();
 else if(Depth==(VA_DEPTH-ONE))
 {
  VA_Link_Alloc();
  Metric_Reinit();
 }
 if(Depth==VA_DEPTH)
  Post_VA_Depth();
 return(0);
}
/******************************************************************************/
/*              Procedures for depth less than 'VA_Depth-1'.
*******************************************************************************/
int Pre_VA_Depth()
{
 VA_Link_Alloc();
 Metric_Reinit();
 Calculate_Metric();
 /*Print_Metrics();*/
 return(0);
}
/******************************************************************************/
/* Do memory allocation for a link. The 'Fst_Depth' corresponds to the
   oldest symbol in time and the 'Lst_Depth' corresponds to the 
   most recent symbol in time.
*******************************************************************************/
int VA_Link_Alloc()
{
 void *tmp;
 void *malloc();
 struct Trellis *curr;
 tmp=malloc(sizeof(struct Trellis));
 Ck_Calloc(tmp);
 curr=(struct Trellis *)tmp;
 if(Depth==ZERO)
  Fst_Depth=curr;
 curr->Prv_Depth=Lst_Depth;
 curr->Nxt_Depth=NULL;
 if(Lst_Depth != NULL)
  Lst_Depth->Nxt_Depth=curr;
 Lst_Depth=curr;                            /* This completes double linking. */
 Depth++;
 return(0);
}
/******************************************************************************/
/*                       Processing at 'VA_Depth'.
*******************************************************************************/
int Post_VA_Depth()
{
 Calculate_Metric();
 /*Print_Metrics();*/
 Get_Min_Metric();
 Get_Last_Symbol();
 Linked_List_Reinit();
 Metric_Reinit();
 return(0);
}
/******************************************************************************/
