/******************************************************************************/
/*                          COUNTER VARIABLES.
*******************************************************************************/
extern long Frame_Cnt;                                        /* Frame count. */
extern long Sym_Cnt;                                         /* Symbol count. */
extern long Err_Cnt;                                   /* Symbol error count. */
extern long Valid_Sym;                                 /* Valid symbol count. */
/******************************************************************************/
/*                      BIT AND SYMBOL VARIABLES.
*******************************************************************************/
extern int Bit[BITS_PER_SYM];                             /* Stores the bits. */
extern int Inp_Sym_Num;                         /* Sym. no. i/p to diff. enc. */
extern int Curr_Tx_Sym_Num;                           /* Curr. tx. symbol no. */
extern int Prev_Tx_Sym_Num;                           /* Prev. tx. symbol no. */
extern double Re_Sym;                          /* Re. part of current symbol. */
extern double Rx_Re_Sym[DIVERSITY];                /* Re. part of rx. symbol. */
extern double Re_Map[CONSTELL_SIZE];                          /* Re. mapping. */
/******************************************************************************/
/*                        FADE GENERATOR VARIABLES.
*******************************************************************************/
extern long Sym_Energy_Cnt;                /* To compute the avg. tx. energy. */
extern unsigned short F1_Store[DIVERSITY][PNS_SIZE];    /* Stores PNS status. */
extern unsigned short F2_Store[DIVERSITY][PNS_SIZE];    /* Stores PNS status. */
extern double F_Val[DIVERSITY][NVALSIZE];        /* Contains U & G rand. var. */
extern double Re_Fade[DIVERSITY];               /* Re. part of fade variable. */
extern double Coeff_Array[PRED_MEM_SIZE];                /* IIR filter coeff. */
extern double Re_F_Reg[PRED_MEM_SIZE];                       /* Re. fade reg. */
extern double Sym_Energy[DIVERSITY];                 /* Energy in the symbol. */
extern double Max_Env_Sq[DIVERSITY];               /* Max. value of envelope. */
extern double Min_Env_Sq[DIVERSITY];               /* Min. value of envelope. */
/******************************************************************************/
/*                       NOISE GENERATOR VARIABLES.
*******************************************************************************/
extern unsigned short N1_Store[DIVERSITY][PNS_SIZE];    /* Stores PNS status. */
extern unsigned short N2_Store[DIVERSITY][PNS_SIZE];    /* Stores PNS status. */
extern double N_Val[DIVERSITY][NVALSIZE];        /* Contains U & G rand. var. */
/******************************************************************************/
/*                   RECEIVER INPUT REGISTER VARIABLES.
*******************************************************************************/
extern double Re_Rx_Reg[DIVERSITY][RX_REG_SIZE];       /* Stores Re. samples. */
/******************************************************************************/
/*                    DIFFERENTIAL DETECTION VARIABLES.
*******************************************************************************/
extern int Diff_Decoded_Sym;                         /* Diff. decoded symbol. */
extern double Rx_Prod;                 /* Prod. of 2 consecutive rx. samples. */
/******************************************************************************/
