/******************************************************************************/
/*                          COUNTER VARIABLES.
*******************************************************************************/
long Frame_Cnt;                                               /* Frame count. */
long Sym_Cnt;                                                /* Symbol count. */
long Err_Cnt;                                          /* Symbol error count. */
long Valid_Sym;                                        /* Valid symbol count. */
/******************************************************************************/
/*                      BIT AND SYMBOL VARIABLES.
*******************************************************************************/
int Bit[BITS_PER_SYM];                                    /* Stores the bits. */
int Inp_Sym_Num;                                /* Sym. no. i/p to diff. enc. */
int Curr_Tx_Sym_Num;                                  /* Curr. tx. symbol no. */
int Prev_Tx_Sym_Num;                                  /* Prev. tx. symbol no. */
double Re_Sym;                                 /* Re. part of current symbol. */
double Rx_Re_Sym[DIVERSITY];                       /* Re. part of rx. symbol. */
double Re_Map[CONSTELL_SIZE];                                 /* Re. mapping. */
/******************************************************************************/
/*                        FADE GENERATOR VARIABLES.
*******************************************************************************/
long Sym_Energy_Cnt;                       /* To compute the avg. tx. energy. */
unsigned short F1_Store[DIVERSITY][PNS_SIZE];           /* Stores PNS status. */
unsigned short F2_Store[DIVERSITY][PNS_SIZE];           /* Stores PNS status. */
double F_Val[DIVERSITY][NVALSIZE];               /* Contains U & G rand. var. */
double Re_Fade[DIVERSITY];                      /* Re. part of fade variable. */
double Coeff_Array[PRED_MEM_SIZE];                       /* IIR filter coeff. */
double Re_F_Reg[PRED_MEM_SIZE];                              /* Re. fade reg. */
double Sym_Energy[DIVERSITY];                        /* Energy in the symbol. */
double Max_Env_Sq[DIVERSITY];                      /* Max. value of envelope. */
double Min_Env_Sq[DIVERSITY];                      /* Min. value of envelope. */
/******************************************************************************/
/*                       NOISE GENERATOR VARIABLES.
*******************************************************************************/
unsigned short N1_Store[DIVERSITY][PNS_SIZE];           /* Stores PNS status. */
unsigned short N2_Store[DIVERSITY][PNS_SIZE];           /* Stores PNS status. */
double N_Val[DIVERSITY][NVALSIZE];               /* Contains U & G rand. var. */
/******************************************************************************/
/*                   RECEIVER INPUT REGISTER VARIABLES.
*******************************************************************************/
double Re_Rx_Reg[DIVERSITY][RX_REG_SIZE];              /* Stores Re. samples. */
/******************************************************************************/
/*                    DIFFERENTIAL DETECTION VARIABLES.
*******************************************************************************/
int Diff_Decoded_Sym;                                /* Diff. decoded symbol. */
double Rx_Prod;                        /* Prod. of 2 consecutive rx. samples. */
/******************************************************************************/
