/******************************************************************************/
#include "p4type.h"
#include "p4ext.h"
/******************************************************************************/
int Simulation()
{
 for(Frame_Cnt=ZERO;Frame_Cnt<MAX_FRAMES;Frame_Cnt++)
 {
  for(Sym_Cnt=ZERO;Sym_Cnt<FRAME_SIZE;Sym_Cnt++)
  {
   Get_Symbol();
   Add_Noise();
   Receive();
  }
 }
 return(0);
}
/******************************************************************************/
/*                        Add white Gaussian noise.
*******************************************************************************/
int Add_Noise()
{
 int cntd;
 double erand48();
 for(cntd=ZERO;cntd<DIVERSITY;cntd++)
 {
  N_Val[cntd][URADIUS]=erand48(N1_Store[cntd]);
  N_Val[cntd][UTHETA]= erand48(N2_Store[cntd]);
  My_Gauss(VARIANCE,N_Val,cntd);
  Rx_Re_Sym[cntd]=Rx_Re_Sym[cntd]+N_Val[cntd][GRAND_0];
 }
 return(0);
}
/******************************************************************************/
/*                         Sample the MF output.
*******************************************************************************/
int Receive()
{
 Shift_In_New_Sample();
 if(Sym_Cnt >= ONE)
 {
  Get_Product();
  Detect();
 }
 return(0);
}
/******************************************************************************/
/*                      Shift in a new complex sample.
*******************************************************************************/
int Shift_In_New_Sample()
{
 int cntd;
 Right_Shift(Re_Rx_Reg);
 for(cntd=ZERO;cntd<DIVERSITY;cntd++)
  Re_Rx_Reg[cntd][ZERO]=Rx_Re_Sym[cntd];
 return(0);
}
/******************************************************************************/
/*             Get the product of the two consecutive samples.
*******************************************************************************/
int Get_Product()
{
 int cntd;
 Rx_Prod=0.0;
 for(cntd=ZERO;cntd<DIVERSITY;cntd++)
  Rx_Prod=Rx_Prod+Re_Rx_Reg[cntd][ZERO]*Re_Rx_Reg[cntd][ONE];
 return(0);
}
/******************************************************************************/
/*                    Perform differential detection.
*******************************************************************************/
int Detect()
{
 if(Rx_Prod > FRAC_ZERO)
  Diff_Decoded_Sym=ZERO;
 else
  Diff_Decoded_Sym=ONE;
 if(Diff_Decoded_Sym != Inp_Sym_Num)
  Err_Cnt++;
 Valid_Sym++;
 return(0);
}
/******************************************************************************/
