/******************************************************************************/
#include <stdio.h>
#include <math.h>
/******************************************************************************/
/*                    SIMULATION RUN LENGTH PARAMETER.
*******************************************************************************/
#define FRAME_SIZE (10000000+1)                           /* Size of a frame. */
#define MAX_FRAMES 1                             /* Length of simulation run. */
/******************************************************************************/
/*                         CONSTELLATION PARAMETERS.
*******************************************************************************/
#define BITS_PER_SYM 1                                    /* Bits per symbol. */
#define CONSTELL_SIZE 2                             /* Size of constellation. */
/******************************************************************************/
/*                            FADING PARAMETERS.
*******************************************************************************/
#define FADING 1                                      /*1:Fading;0:otherwise. */
#define F_VARIANCE 0.5                   /* Variance of the Gaussian process. */
#define F_BIAS 0.0                                       /* Direct component. */
/******************************************************************************/
/*                  GAUSSIAN NOISE GENERATOR PARAMETERS.
*******************************************************************************/
#define VARIANCE 0.00000                                   /* Noise variance. */
#define PNS_SIZE 3                     /* Size of array used to generate PNS. */
#define NVALSIZE 4
#define URADIUS 0
#define UTHETA 1
#define GRAND_0 2
#define GRAND_1 3
/******************************************************************************/
/*                    RECEIVER REGISTER PARAMETERS.
*******************************************************************************/
#define RX_REG_SIZE 2                       /* Size of the receiver register. */
/******************************************************************************/
/*                    PARAMETERS RELATED TO DIVERSITY.
*******************************************************************************/
#define DIVERSITY 1                             /* No. of diversity channels. */
/******************************************************************************/
/*                   PARAMETERS RELATED TO THE PREDICTOR.
*******************************************************************************/
#define PRED_MEM_SIZE 3                      /* Size of the predictor memory. */
/******************************************************************************/
/*                             CONSTANTS.
*******************************************************************************/
#define BINSIZE 16         /* Size of array to store states in binary format. */
#define TWO 2
#define ONE 1
#define ZERO 0
#define TRUE 1
#define FALSE 0
#define LEFT 0
#define RIGHT 1
#define MINUSONE (-1)
#define ERROR 0.000001
#define FRAC_ZERO 0.0
#define MY_PI 3.14159265358979323846
#define PIBY2 1.57079632679489661923
#define PIBY4 0.785398163397448309615
#define TWICEPI 6.28318530717958647692
/******************************************************************************/
