/******************************************************************************/
#include "p5type.h"
#include "p5ext.h"
/******************************************************************************/
/*                   Initialize simulation variables.
*******************************************************************************/
int Sim_Init()
{
 Sym_Init();
 Err_Buf_Init();
 Fade_Gen_Init();
 Fade_Var_Init();
 Fade_Env_Init();
 Fade_Coeff_Init();
 Noise_Gen_Init();
 VA_Init();
 return(0);
}
/******************************************************************************/
/*                 Initialize symbol related variables.
*******************************************************************************/
int Sym_Init()
{
 Prev_Tx_Sym_Num=ZERO;
 return(0);
}
/******************************************************************************/
/*                      Initialize the error buffer.
*******************************************************************************/
int Err_Buf_Init()
{
 Err_Buf_Inx=ZERO;
 Err_Cnt=ZERO;
 Valid_Sym=ZERO;
 return(0);
}
/******************************************************************************/
/*                     Initialize the fading parameters.
*******************************************************************************/
int Fade_Gen_Init()
{
 int cntd,cntp;
 int random(void);
 for(cntd=ZERO;cntd<DIVERSITY;cntd++)
 {
  for(cntp=ZERO;cntp<PNS_SIZE;cntp++)
   F1_Store[cntd][cntp]=(unsigned short)random();
  for(cntp=ZERO;cntp<PNS_SIZE;cntp++)
   F2_Store[cntd][cntp]=(unsigned short)random();
 }
 return(0);
}
/******************************************************************************/
/*                      Initialize the fade variables.
*******************************************************************************/
int Fade_Var_Init()
{
 int cntd;
 double erand48();
 for(cntd=ZERO;cntd<DIVERSITY;cntd++)
 {
  F_Val[cntd][URADIUS]=erand48(F1_Store[cntd]);
  F_Val[cntd][UTHETA]= erand48(F2_Store[cntd]);
  My_Gauss(F_VARIANCE,F_Val,cntd);
  Re_Fade[cntd]=F_Val[cntd][GRAND_0];
  Im_Fade[cntd]=F_Val[cntd][GRAND_1];
 }
 return(0);
}
/******************************************************************************/
/*                      Initialize the fade envelope.
*******************************************************************************/
int Fade_Env_Init()
{
 int cntd,cnt;
 for(cntd=ZERO;cntd<DIVERSITY;cntd++)
 {
  Max_Env_Sq[cntd]= -1.0;
  Min_Env_Sq[cntd]=1000000.0;
  Sym_Energy[cntd]=0.0;
 }
 for(cntd=ZERO;cntd<DIVERSITY;cntd++)
 {
  for(cnt=ZERO;cnt<PRED_MEM_SIZE;cnt++)
   Re_F_Reg[cntd][cnt]=Im_F_Reg[cntd][cnt]=0.0;
 }
 Sym_Energy_Cnt=ZERO;
 return(0);
}
/******************************************************************************/
/*                     Initialize the fade coefficients.
*******************************************************************************/
int Fade_Coeff_Init()
{
 double tmp;
 /*Ip_Coeff=0.008;
 tmp=0.8;
 Coeff_Array[0]= -3.0*tmp;
 Coeff_Array[1]=  3.0*tmp*tmp;
 Coeff_Array[2]= -tmp*tmp*tmp;*/
 tmp=0.995;
 Ip_Coeff=sqrt(1.0-tmp*tmp);
 Coeff_Array[0]= -tmp;
 return(0);
}
/******************************************************************************/
/*                     Initialize the noise generator.
*******************************************************************************/
int Noise_Gen_Init()
{
 int cntd,cntp;
 int random(void);
 for(cntd=ZERO;cntd<DIVERSITY;cntd++)
 {
  for(cntp=ZERO;cntp<PNS_SIZE;cntp++)
   N1_Store[cntd][cntp]=(unsigned short)random();
  for(cntp=ZERO;cntp<PNS_SIZE;cntp++)
   N2_Store[cntd][cntp]=(unsigned short)random();
 }
 return(0);
}
/******************************************************************************/
/*                           Initialize the VA.
*******************************************************************************/
int VA_Init()
{
 Depth=ZERO;
 Fst_Depth=Lst_Depth=NULL;
 Prev_VA_Op_Sym_Num=Curr_VA_Op_Sym_Num= MINUSONE;
 Min_Wght_St=ZERO;
 return(0);
}
/******************************************************************************/
