/******************************************************************************/
#include "p5type.h"
#include "p5ext.h"
/******************************************************************************/
int Post_Processor()
{
 Print_Info();
 Final_Print_Metrics();
 return(0);
}
/******************************************************************************/
/*                      Print general information.
*******************************************************************************/
int Print_Info()
{
 int cntd;
 double avg;
 printf("\t Total symbols transmitted is %ld.\n\n",Sym_Energy_Cnt);
 printf("\t Number of valid symbols is %ld.\n\n",Valid_Sym);
 printf("\t No. of symbol errors is %ld.\n\n",Err_Cnt);
 for(cntd=ZERO;cntd<DIVERSITY;cntd++)
 {
  avg=Sym_Energy[cntd]/(double)Sym_Energy_Cnt;
  printf("\t Div:%3d Max. sq. env is %16.12lf.\n\n",cntd,Max_Env_Sq[cntd]);
  printf("\t Div:%3d Min. sq. env is %16.12lf.\n\n",cntd,Min_Env_Sq[cntd]);
  printf("\t Total energy is %16.12lf.\n\n",Sym_Energy[cntd]);
  printf("\t Avg. transmitted energy is %16.12lf.\n\n",avg);
 }
 return(0);
}
/******************************************************************************/
/*                           Print the metrics.
*******************************************************************************/
int Final_Print_Metrics()
{
 int cnt;
 struct Trellis *prv;
 prv=Lst_Depth->Prv_Depth;
 for(cnt=ZERO;cnt<NUM_STATES;cnt++)
 {
  printf("\t State:%3d ",cnt);
  printf(" Error:%lf\n",prv->VA_Error[cnt]);
 }
 return(0);
}
/******************************************************************************/
