/******************************************************************************/
#include "p5type.h"
#include "p5ext.h"
/******************************************************************************/
/*                          Convert decimal to M-ary.
*******************************************************************************/
int Decimal_To_M_ary(state,m_array)
int state,m_array[PRED_MEM_SIZE];
{
 int cnt;
 for(cnt=ZERO;cnt<PRED_MEM_SIZE;cnt++)
  m_array[cnt]=ZERO;
 cnt=ZERO;
 while(state>ZERO)
 {
  if(cnt == PRED_MEM_SIZE)
   Error_Mes(18);
  m_array[cnt]=state%CONSTELL_SIZE;
  state=state/CONSTELL_SIZE;
  cnt++;
 }
 return(0);
}
/******************************************************************************/
/*                          Convert M-ary to decimal.
*******************************************************************************/
int M_ary_To_Decimal(m_array)
int m_array[PRED_MEM_SIZE];
{
 int cnt,state,power;
 state=ZERO;
 power=ONE;
 for(cnt=ZERO;cnt<PRED_MEM_SIZE;cnt++)
 {
  state=state+m_array[cnt]*power;
  power=power*CONSTELL_SIZE;
 }
 return(state);
}
/******************************************************************************/
/*                            Binary to decimal.
*******************************************************************************/
int Binary_to_Decimal(array,size)
int array[];
int size;
{
 int cnt,power,num;
 power=ONE;
 num=ZERO;
 for(cnt=ZERO;cnt<size;cnt++)
 {
  num=num+power*Bit[cnt];
  power=2*power;
 }
 return(num);
}
/******************************************************************************/
/*   Shifts the contents of the register to the right to allow a new sample.
*******************************************************************************/
int Right_Shift(rereg,imreg)
double rereg[DIVERSITY][RX_REG_SIZE],imreg[DIVERSITY][RX_REG_SIZE];
{
 int cnt,cntd;
 for(cntd=ZERO;cntd<DIVERSITY;cntd++)
 {
  for(cnt=RX_REG_SIZE-ONE;cnt>ZERO;cnt--)
  {
   rereg[cntd][cnt]=rereg[cntd][cnt-ONE];
   imreg[cntd][cnt]=imreg[cntd][cnt-ONE];
  }
 }
 return(0);
}
/******************************************************************************/
/*       Convert uniform random variables to gaussian random variables.
*******************************************************************************/
int My_Gauss(tvar,tnarry,cntd)
int cntd;
double tvar,tnarry[DIVERSITY][NVALSIZE];
{
 double r,theta;
 r= -2.0*tvar*log(1.0-tnarry[cntd][URADIUS]);
 if(r < FRAC_ZERO)
  Error_Mes(10);
 r=sqrt(r);
 theta=2.0*MY_PI*tnarry[cntd][UTHETA];
 tnarry[cntd][GRAND_0]=r*cos(theta);
 tnarry[cntd][GRAND_1]=r*sin(theta);
 return(0);
}
/******************************************************************************/
/*                 Check for memory allocation failure.
*******************************************************************************/
int Ck_Calloc(tmp)
void *tmp;
{
 if(tmp==NULL)
  exit(3);
 return(0);
}
/******************************************************************************/
/*                             Error message.
*******************************************************************************/
int Error_Mes(num)
int num;
{
 fprintf(stdout,"\t Simulation error. Exiting with code %d.\n\n",num);
 fflush(stdout);
 exit(num);
 return(0);
}
/******************************************************************************/
