/******************************************************************************/
#include "p6type.h"
#include "p6ext.h"
/******************************************************************************/
int Simulation()
{
 for(Sym_Cnt=ZERO;Sym_Cnt<MAX_SYM;Sym_Cnt++)
 {
  Get_Symbol();
  Add_Noise();
  Receive();
 }
 return(0);
}
/******************************************************************************/
/*                        Add white Gaussian noise.
*******************************************************************************/
int Add_Noise()
{
 int cntd;
 double erand48();
 for(cntd=ZERO;cntd<DIVERSITY;cntd++)
 {
  N_Val[cntd][URADIUS]=erand48(N1_Store[cntd]);
  N_Val[cntd][UTHETA]= erand48(N2_Store[cntd]);
  My_Gauss(VARIANCE,N_Val,cntd);
  Rx_Re_Sym[cntd]=Rx_Re_Sym[cntd]+N_Val[cntd][GRAND_0];
  Rx_Im_Sym[cntd]=Rx_Im_Sym[cntd]+N_Val[cntd][GRAND_1];
 }
 return(0);
}
/******************************************************************************/
/*                         Sample the MF output.
*******************************************************************************/
int Receive()
{
 Shift_In_New_Sample();
 if(Sym_Cnt >= ONE)
 {
  Get_Product();
  Detect();
  Update_Error();
 }
 return(0);
}
/******************************************************************************/
/*                      Shift in a new complex sample.
*******************************************************************************/
int Shift_In_New_Sample()
{
 int cntd;
 Right_Shift(Re_Rx_Reg,Im_Rx_Reg);
 for(cntd=ZERO;cntd<DIVERSITY;cntd++)
 {
  Re_Rx_Reg[cntd][ZERO]=Rx_Re_Sym[cntd];
  Im_Rx_Reg[cntd][ZERO]=Rx_Im_Sym[cntd];
 }
 return(0);
}
/******************************************************************************/
/*             Get the product of the two consecutive samples.
*******************************************************************************/
int Get_Product()
{
 int cntd;
 Re_Rx_Prod=Im_Rx_Prod=0.0;
 for(cntd=ZERO;cntd<DIVERSITY;cntd++)
 {
  Re_Rx_Prod=Re_Rx_Prod+Re_Rx_Reg[cntd][ZERO]*Re_Rx_Reg[cntd][ONE];
  Re_Rx_Prod=Re_Rx_Prod+Im_Rx_Reg[cntd][ZERO]*Im_Rx_Reg[cntd][ONE];
  Im_Rx_Prod=Im_Rx_Prod-Re_Rx_Reg[cntd][ZERO]*Im_Rx_Reg[cntd][ONE];
  Im_Rx_Prod=Im_Rx_Prod+Im_Rx_Reg[cntd][ZERO]*Re_Rx_Reg[cntd][ONE];
 }
 return(0);
}
/******************************************************************************/
/*                            Detect the symbol.
*******************************************************************************/
int Detect()
{
 int cnt;
 double re_prod,max;
 max= MIN;
 for(cnt=ZERO;cnt<CONSTELL_SIZE;cnt++)
 {
  re_prod=Re_Rx_Prod*Re_Map[cnt]+Im_Rx_Prod*Im_Map[cnt];
  if(re_prod > max)
  {
   max=re_prod;
   Diff_Decoded_Sym=cnt;
  }
 }
 return(0);
}
/******************************************************************************/
/*                     Update the symbol error count.
*******************************************************************************/
int Update_Error()
{
 int cnt;
 Valid_Sym++;
 if(Inp_Sym_Num != Diff_Decoded_Sym)
 {
  /*printf("frmcnt:%d symcnt:%d ",Frame_Cnt,Sym_Cnt);
  printf("tx sym:%d rx sym:%d\n",Err_Buf[4],Diff_Decoded_Sym);*/
  Err_Cnt++;
 }
 return(0);
}
/******************************************************************************/
