/******************************************************************************/
#include "p7type.h"
#include "p7ext.h"
/******************************************************************************/
/*                   Initialize simulation variables.
*******************************************************************************/
int Sim_Init()
{
 Err_Cnt_Init();
 Fade_Gen_Init();
 Fade_Var_Init();
 Noise_Gen_Init();
 return(0);
}
/******************************************************************************/
/*                      Initialize the error buffer.
*******************************************************************************/
int Err_Cnt_Init()
{
 Err_Cnt=ZERO;
 return(0);
}
/******************************************************************************/
/*                     Initialize the fading parameters.
*******************************************************************************/
int Fade_Gen_Init()
{
 int random(void);
 F1_Store[0]=(unsigned short)random();
 F1_Store[1]=(unsigned short)random();
 F1_Store[2]=(unsigned short)random();
 F2_Store[0]=(unsigned short)random();
 F2_Store[1]=(unsigned short)random();
 F2_Store[2]=(unsigned short)random();
 printf("\t F1_store:0:%d 1:%d 2:%d\n",F1_Store[0],F1_Store[1],F1_Store[2]);
 printf("\t F2_store:0:%d 1:%d 2:%d\n",F2_Store[0],F2_Store[1],F2_Store[2]);
 return(0);
}
/******************************************************************************/
/*                      Initialize the fade variables.
*******************************************************************************/
int Fade_Var_Init()
{
 double tmp;
 Re_Fade=Im_Fade=0.0;
 Ip_Coeff=0.008;
 tmp=0.8;
 Coeff_Array[0]= -3.0*tmp;
 Coeff_Array[1]=  3.0*tmp*tmp;
 Coeff_Array[2]= -tmp*tmp*tmp;
 Max_Env_Sq= -1.0;
 Min_Env_Sq=1000000.0;
 Sym_Energy=0.0;
 Sym_Energy_Cnt=ZERO;
 return(0);
}
/******************************************************************************/
/*                     Initialize the noise generator.
*******************************************************************************/
int Noise_Gen_Init()
{
 int random(void);
 N1_Store[0]=random();
 N1_Store[1]=random();
 N1_Store[2]=random();
 N2_Store[0]=random();
 N2_Store[1]=random();
 N2_Store[2]=random();
 return(0);
}
/******************************************************************************/
