/******************************************************************************/
#include "p7type.h"
#include "p7ext.h"
/******************************************************************************/
/*                   Get the symbol to be transmitted.
*******************************************************************************/
int Get_Symbol()
{
 Get_Bits();
 Tx_Sym_Num=Binary_to_Decimal(Bit,BITS_PER_SYM);
 Mapping();
 Introduce_Fading();
 return(0);
}
/******************************************************************************/
/*                              Get the bits.
*******************************************************************************/
int Get_Bits()
{
 int cnt;
 int random(void);
 for(cnt=ZERO;cnt<BITS_PER_SYM;cnt++)
  Bit[cnt]=random()&1;
 return(0);
}
/******************************************************************************/
/*                               Map to symbol.
*******************************************************************************/
int Mapping()
{
 Re_Sym=Re_Map[Tx_Sym_Num];
 Im_Sym=Im_Map[Tx_Sym_Num];
 return(0);
}
/******************************************************************************/
/*                            Introduce fading.
*******************************************************************************/
int Introduce_Fading()
{
 Get_Cmplx_Variable();
 Get_Modified_Symbol();
 return(0);
}
/******************************************************************************/
/*                    Get the complex random variable.
*******************************************************************************/
int Get_Cmplx_Variable()
{
 double mag,re_tmp,im_tmp;
 double erand48();
 F_Val[URADIUS]=erand48(F1_Store);
 F_Val[UTHETA]=erand48(F2_Store);
 My_Gauss(F_VARIANCE,F_Val);
 Get_Re_Fade();
 Get_Im_Fade();
 Update_Env();
 return(0);
}
/******************************************************************************/
/*                            Get Re. fade.
*******************************************************************************/
int Get_Re_Fade()
{
 int cnt;
 Re_Fade=Ip_Coeff*F_Val[GRAND_0];
 for(cnt=ZERO;cnt<PRED_MEM_SIZE;cnt++)
  Re_Fade=Re_Fade-Coeff_Array[cnt]*Re_F_Reg[cnt];
 for(cnt=PRED_MEM_SIZE-ONE;cnt>ZERO;cnt--)
  Re_F_Reg[cnt]=Re_F_Reg[cnt-ONE];
 Re_F_Reg[ZERO]=Re_Fade;
 return(0);
}
/******************************************************************************/
/*                            Get Im. fade.
*******************************************************************************/
int Get_Im_Fade()
{
 int cnt;
 Im_Fade=Ip_Coeff*F_Val[GRAND_1];
 for(cnt=ZERO;cnt<PRED_MEM_SIZE;cnt++)
  Im_Fade=Im_Fade-Coeff_Array[cnt]*Im_F_Reg[cnt];
 for(cnt=PRED_MEM_SIZE-ONE;cnt>ZERO;cnt--)
  Im_F_Reg[cnt]=Im_F_Reg[cnt-ONE];
 Im_F_Reg[ZERO]=Im_Fade;
 return(0);
}
/******************************************************************************/
/*         Update the maximum and minimum values of the envelope.
*******************************************************************************/
int Update_Env()
{
 double mag,re_tmp,im_tmp;
 re_tmp=Re_Fade+F_BIAS;
 im_tmp=Im_Fade+F_BIAS;
 mag=re_tmp*re_tmp+im_tmp*im_tmp;
 if(mag > Max_Env_Sq)
  Max_Env_Sq=mag;
 else if(mag < Min_Env_Sq)
  Min_Env_Sq=mag;
 return(0);
}
/******************************************************************************/
/*                        Get the modified symbol.
*******************************************************************************/
int Get_Modified_Symbol()
{
 double rtmp,itmp;
 rtmp=Re_Sym*(Re_Fade+F_BIAS)-Im_Sym*(Im_Fade+F_BIAS);
 itmp=Re_Sym*(Im_Fade+F_BIAS)+Im_Sym*(Re_Fade+F_BIAS);
 Re_Sym=rtmp;
 Im_Sym=itmp;
 Sym_Energy=Sym_Energy+Re_Sym*Re_Sym+Im_Sym*Im_Sym;
 Sym_Energy_Cnt++;
 return(0);
}
/******************************************************************************/
