/******************************************************************************/
#include <stdio.h>
#include <math.h>
/******************************************************************************/
/*                   PARAMETERS RELATED TO THE PREDICTOR.
*******************************************************************************/
#define PRED_MEM_SIZE 3                      /* Size of the predictor memory. */
/******************************************************************************/
/*                    SIMULATION RUN LENGTH PARAMETER.
*******************************************************************************/
#define MAX_SYM 10000000                      /* Length of simulation run. */
/******************************************************************************/
/*                         CONSTELLATION PARAMETERS.
*******************************************************************************/
#define QAM_TYPE 0                                     /* Constellation type. */
#define BITS_PER_SYM 3                                    /* Bits per symbol. */
#define CONSTELL_SIZE 8                             /* Size of constellation. */
#define SYM_PER_RADIUS 4                               /* Symbols per radius. */
/******************************************************************************/
/*                           FADING PARAMETERS.
*******************************************************************************/
#define F_VARIANCE 0.5                     /* Variance of the fading process. */
#define F_BIAS 0.000000                                     /* LOS component. */
/*#define F_BIAS 2.236068*/                                 /* LOS component. */
/******************************************************************************/
/*                  GAUSSIAN NOISE GENERATOR PARAMETERS.
*******************************************************************************/
#define VARIANCE 0.00000                                   /* Noise variance. */
#define NVALSIZE 4
#define URADIUS 0
#define UTHETA 1
#define GRAND_0 2
#define GRAND_1 3
/******************************************************************************/
/*                         ERROR BUFFER PARAMETERS.
*******************************************************************************/
#define ERR_BUF_SIZE 64                              /* Size of error buffer. */
/******************************************************************************/
/*                             CONSTANTS.
*******************************************************************************/
#define BINSIZE 16         /* Size of array to store states in binary format. */
#define TWO 2
#define ONE 1
#define ZERO 0
#define TRUE 1
#define FALSE 0
#define LEFT 0
#define RIGHT 1
#define MINUSONE (-1)
#define ERROR 0.000001
#define FRAC_ZERO 0.0
#define THRESH 10000.0
#define MY_PI 3.14159265358979323846
#define PIBY2 1.57079632679489661923
#define PIBY4 0.785398163397448309615
#define TWICEPI 6.28318530717958647692
/******************************************************************************/
