/******************************************************************************/
#include "p8type.h"
#include "p8ext.h"
/******************************************************************************/
/*                    Check for validity of variables.
*******************************************************************************/
int Ck_Var()
{
 Check_Bits_Per_Sym();
 Check_Constellation_Size();
 Check_Diversity();
 Check_Num_States();
 Check_Rx_Reg_Size();
 return(0);
}
/******************************************************************************/
/*                        Check bits per symbol.
*******************************************************************************/
int Check_Bits_Per_Sym()
{
 if(BITS_PER_SYM < 3)
  Error_Mes(5);
 return(0);
}
/******************************************************************************/
/*                        Check constellation size.
*******************************************************************************/
int Check_Constellation_Size()
{
 int power,cnt;
 power=ONE;
 for(cnt=ZERO;cnt<BITS_PER_SYM;cnt++)
  power=2*power;
 if(power != CONSTELL_SIZE)
  Error_Mes(7);
 return(0);
}
/******************************************************************************/
/*                          Check the diversity.
*******************************************************************************/
int Check_Diversity()
{
 if(DIVERSITY < ONE)
  Error_Mes(17);
 return(0);
}
/******************************************************************************/
/*                       Check the number of states.
*******************************************************************************/
int Check_Num_States()
{
 int power,cnt;
 power=ONE;
 for(cnt=ZERO;cnt<(PRED_MEM_SIZE-ONE);cnt++)
  power=CONSTELL_SIZE*power;
 if(power != NUM_STATES)
  Error_Mes(19);
 return(0);
}
/******************************************************************************/
/*                  Check the size of the receiver register.
*******************************************************************************/
int Check_Rx_Reg_Size()
{
 if(RX_REG_SIZE != (PRED_MEM_SIZE+ONE))
  Error_Mes(20);
 return(0);
}
/******************************************************************************/
