/******************************************************************************/
#include "p8type.h"
#include "p8ext.h"
/******************************************************************************/
int Pre_Processor()
{
 Ck_Var();
 Get_Mapping();
 Get_Inv_Mapping();
 Get_Trellis();
 Sim_Init();
 return(0);
}
/******************************************************************************/
/*                           Get real mapping.
*******************************************************************************/
int Get_Mapping()
{
 int cnt;
 double tmp,inx,size;
 tmp=0.5*(2.0+(1.0+sqrt(3.0))*(1.0+sqrt(3.0)));
 tmp=sqrt(tmp);
 size=(double)CONSTELL_SIZE;
 for(cnt=ZERO;cnt<CONSTELL_SIZE;cnt++)
 {
  inx=(double)cnt;
  Re_Map[cnt]=tmp*cos(inx*2.0*MY_PI/size);
  Im_Map[cnt]=tmp*sin(inx*2.0*MY_PI/size);
 }
 return(0);
}
/******************************************************************************/
/*                     Get the inverse of the symbols.
*******************************************************************************/
int Get_Inv_Mapping()
{
 int cnt;
 double magsq;
 for(cnt=ZERO;cnt<CONSTELL_SIZE;cnt++)
 {
  magsq=Re_Map[cnt]*Re_Map[cnt]+Im_Map[cnt]*Im_Map[cnt];
  if(magsq<ERROR)
   Error_Mes(22);
  Re_Inv_Map[cnt]=  Re_Map[cnt]/magsq;
  Im_Inv_Map[cnt]= -Im_Map[cnt]/magsq;
 }
 return(0);
}
/******************************************************************************/
